import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react'
import styles from './index.module.scss'
import { useParams } from 'react-router-dom'
import { FourTableType } from '@/pages/B_enterTibet/B1collect/type'
import { C1GoodType } from '@/pages/A3_ledger/C1ledger/type'
import {
  D4_APIcreate,
  D4_APIdel,
  D4_APIgetInfo,
  D4_APIgetStorageNum,
  D4_APIrevocation,
  D4_APIsaveApply,
  D4_APIsaveAudit,
  D4_APIsaveCreate,
  D4_APIsaveDraft
} from '@/store/action/D4impStor'
import dayjs from 'dayjs'
import { MessageFu } from '@/utils/message'
import history, {
  btnFlagFu2,
  cascaderObjFu,
  infoPageBackFu,
  openGoodsInfoFu
} from '@/utils/history'
import classNames from 'classnames'
import { Button, Cascader, DatePicker, Input, InputNumber, Select } from 'antd'
import MyPopconfirm from '@/components/MyPopconfirm'
import { EXbtnFu } from '@/utils/EXBtn'
import X3auditInfo from '@/pages/X_stock/X3auditInfo'
import { D4tableCgoods, statusObj } from '@/utils/tableData'
import { useDispatch, useSelector } from 'react-redux'
import { D2_APIgetList } from '@/store/action/D2storSet'
import { RootState } from '@/store'
import { FourAPI_getList } from '@/store/action/FourAll'
import MyTable from '@/components/MyTable'
import ZflowTable from '@/components/ZflowTable'
import ZupFileTable from '@/components/ZupFileTable'
import Y1cathet from '@/pages/Y_goodsDetails/Y1cathet'
import ZGaddNow from '@/components/ZGaddNow'
import TextArea from 'antd/es/input/TextArea'
import D4check, { D4checkArrType } from './D4check'
import { API_goodsInfo } from '@/store/action/C1ledger'
import { findFirstDuplicate } from '../data'
import { EXPORT_WORD_ENUM } from '@/utils/exportTemplates'

export const pageTitTxtObj = {
  1: '新增',
  2: '编辑',
  3: '审批',
  4: '查看'
}

function D4edit() {
  // 获取库房设置列表/入馆凭证号-用于分库缩写下拉
  const dispatch = useDispatch()

  useEffect(() => {
    dispatch(D2_APIgetList({ pageNum: 1, pageSize: 99999 }))
    dispatch(FourAPI_getList({ pageNum: 1, pageSize: 99999 }, '1'))
  }, [dispatch])

  const { list: storageIdArr } = useSelector((state: RootState) => state.D2storSet.tableInfo)
  const { list: relatedOrderNumArr } = useSelector((state: RootState) => state.FourAll.listObj['1'])

  const { key, id } = useParams<any>()
  // key:1 新增 2编辑 3审批 4查看
  // 滚到顶部
  const sollrDom = useRef<HTMLDivElement>(null)
  // 顶部数据
  const [topInfo, setTopInfo] = useState({} as FourTableType)

  // 藏品清单快照数据
  const [snaps, setSnaps] = useState<C1GoodType[]>([])
  const delSnapIdsRef = useRef<number[]>([])

  const snapsID2ref = useRef<{ goodsId: number; id: number }[]>([])

  // 创建订单
  const creatFu = useCallback(async () => {
    const res = await D4_APIcreate()
    if (res.code === 0) {
      // 从藏品详情点击按钮进来
      const urlAll = window.location.href
      if (urlAll.includes('?id=')) {
        const urlId = urlAll.split('?id=')[1]
        const res2 = await API_goodsInfo(Number(urlId), 7)
        if (res2.code === 0) {
          setTopInfo({ ...res.data, storageId: res2.data.storageId })
          setSnaps([res2.data])
        }
      } else setTopInfo(res.data)
    }
  }, [])

  // 获取详情
  const getInfoFu = useCallback(
    async (id2?: number) => {
      const res = await D4_APIgetInfo(id2 || id)
      if (res.code === 0) {
        const data = res.data

        setTopInfo(data)

        // 藏品清单快照信息id对比
        const arrTemp: any = []
        const snapsTemp = data.snaps || []

        snapsTemp.forEach((v: any) => {
          snapsID2ref.current.push({ goodsId: v.goodsId, id: v.id })

          const obj = JSON.parse(v.snap || '{}')
          if (obj.id) obj.id2 = v.id

          arrTemp.push(obj)
        })
        setSnaps(arrTemp)
      }
    },
    [id]
  )

  useEffect(() => {
    if (key === '1') creatFu()
    else getInfoFu()

    if (sollrDom.current) sollrDom.current.scrollTop = 0
  }, [creatFu, getInfoFu, key])

  const pageTitTxt = useMemo(() => {
    return Reflect.get(pageTitTxtObj, key)
  }, [key])

  const timeChange = useCallback(
    (e: any, key: 'date') => {
      setTopInfo({ ...topInfo, [key]: dayjs(e).format('YYYY-MM-DD') })
    },
    [topInfo]
  )

  // 审批意见的ref
  const ZAuditRef = useRef<any>(null)

  // 审批的sta
  const [auditSta, setAuDitSta] = useState('')

  // 字段的校验
  const checkFu = useCallback(() => {
    if (!topInfo.date) {
      MessageFu.warning('请选择入库日期')
      return true
    }
    if (!topInfo.num) {
      MessageFu.warning('请输入入库单编号')
      return true
    }
    if (!topInfo.storageId) {
      MessageFu.warning('请选择分库缩写')
      return true
    }
  }, [topInfo])

  // 新增的底部按钮点击
  const btnClickFu = useCallback(
    async (val: '草稿' | '创建' | '保存' | '审批') => {
      if (checkFu()) {
        if (sollrDom.current) sollrDom.current.scrollTop = 0
        return
      }

      if (val !== '草稿') {
        if (snaps.length === 0) return MessageFu.warning('请添加藏品')
        if (snaps.some(v => !v.siteNum)) return MessageFu.warning('请输入藏品分库号')
        // 分库号输入重复校验
        const siteNumArr = snaps.map(v => v.siteNum!)
        const num = findFirstDuplicate(siteNumArr)
        if (num) return MessageFu.warning(`分库号${num}重复`)
      }

      if (val === '审批') {
        // console.log('审批信息富文本', rtf2)
        if (!auditSta) {
          if (sollrDom.current) sollrDom.current.scrollTop = 0
          return MessageFu.warning('请选择审批结果')
        }
        const rtf2 = ZAuditRef.current?.resData()

        const res: any = await D4_APIsaveAudit({
          orderId: topInfo.id,
          rtfOpinion: rtf2,
          status: auditSta === '同意' ? 1 : 2
        })

        if (res.code === 0) {
          MessageFu.success('审批成功')
          // 跳详情页
          history.push(`/impStor_edit/4/${topInfo.id}`)
        } else if (res.code === 3101) {
          const data = JSON.parse(res.msg || '[]')
          setCheckArr(data)
        }
      } else {
        const obj = {
          ...topInfo,
          goodsIds: snaps.map(v => v.id).join(','),
          siteNums: snaps.map(v => v.siteNum).join(','),
          delSnapIds: delSnapIdsRef.current.length ? delSnapIdsRef.current : '',
          snaps: snaps.map(v => ({
            goodsId: v.id,
            id: v.id2 ? v.id2 : null,
            orderId: topInfo.id,
            siteNum: v.siteNum,
            snap: JSON.stringify(v)
          }))
        }
        // console.log(123, obj.snaps)

        // if (1 + 1 === 2) return

        if (val === '草稿') {
          // 存草稿 当前页保存 不跳转
          const res = await D4_APIsaveDraft(obj)
          if (res.code === 0) {
            MessageFu.success('草稿保存成功')
            getInfoFu(topInfo.id)
          }
        } else {
          const res: any = val === '创建' ? await D4_APIsaveCreate(obj) : await D4_APIsaveApply(obj)
          if (res.code === 0) {
            MessageFu.success(`${val}成功`)
            // 跳到详情页
            history.push(`/impStor_edit/4/${topInfo.id}`)
          } else if (res.code === 3101) {
            const data = JSON.parse(res.msg || '[]')
            // setCheckArr(data)
            const siteNumArr = data.map((v: any) => v.siteNum)
            MessageFu.warning(`分库号${siteNumArr}已存在`)
          }
        }
      }
    },
    [auditSta, checkFu, getInfoFu, snaps, topInfo]
  )

  // 打开侧边栏
  const [cathet, setCathet] = useState(0)

  // 表格的输入框改变
  const tableInputChange = useCallback(
    (id: number, val: number | null, key: 'siteNum') => {
      setSnaps(
        snaps.map(v => ({
          ...v,
          [key]: v.id === id ? val : v[key]
        }))
      )
    },
    [snaps]
  )

  const startBtn = useMemo(() => {
    return [
      {
        title: '藏品编号',
        render: (item: C1GoodType) => {
          return (
            <span
              onClick={() => setCathet(item.id)}
              className={classNames('D1GtNum', item.id === cathet ? 'D1GtNumAc' : '')}
            >
              {item.num || '（空）'}
            </span>
          )
        }
      },
      {
        title: '编号类型',
        render: (item: C1GoodType) => item.numName || '（空）'
      },
      {
        title: (
          <div>
            <span style={{ color: '#ff4d4f' }}> * </span>藏品分库号
          </div>
        ),
        width: 160,
        render: (item: C1GoodType) => (
          <InputNumber
            style={{ width: 140 }}
            disabled={!topInfo.storageId}
            readOnly={['3', '4'].includes(key)}
            min={1}
            max={99999999}
            precision={0}
            value={item.siteNum}
            onChange={e => tableInputChange(item.id, e, 'siteNum')}
            placeholder={!topInfo.storageId ? '请先选择分库缩写' : '请输入'}
          />
        )
      }
    ]
  }, [cathet, key, tableInputChange, topInfo.storageId])

  const tableLastBtn = useMemo(() => {
    return [
      {
        title: '备注',
        width: 240,
        render: (item: C1GoodType) => (
          <TextArea
            readOnly={['3', '4'].includes(key)}
            placeholder={
              ['3', '4'].includes(key) && !item.beiZhu ? '（空）' : '请输入内容，不超过200字'
            }
            maxLength={200}
            value={item.beiZhu}
            onChange={e =>
              setSnaps(
                snaps.map(v => ({
                  ...v,
                  beiZhu: v.id === item.id ? e.target.value.trim() : v.beiZhu
                }))
              )
            }
          />
        )
      },
      {
        title: '操作',
        render: (item: C1GoodType) => {
          return (
            <>
              <Button size='small' type='text' onClick={() => openGoodsInfoFu(item.id, 7)}>
                查看
              </Button>
              {['3', '4'].includes(key) ? null : (
                <MyPopconfirm
                  txtK='删除'
                  onConfirm={() => {
                    if (item.id2 && !delSnapIdsRef.current.includes(item.id2))
                      delSnapIdsRef.current.push(item.id2)
                    setSnaps(snaps.filter(v => v.id !== item.id))
                  }}
                />
              )}
            </>
          )
        }
      }
    ]
  }, [key, snaps])

  // 点击添加按钮
  const [nowSta, setNowSta] = useState({ key: '', id: '' })

  // 查看的按钮创建-提交-撤回
  const lookBtnFu = useCallback(
    async (val: '创建' | '提交' | '撤回') => {
      if (val !== '撤回') {
        if (snaps.length === 0) {
          if (val === '创建') history.push(`/impStor_edit/2/${id}`)
          return MessageFu.warning('请添加藏品')
        }
        if (snaps.some(v => !v.siteNum)) return MessageFu.warning('请输入藏品分库号')
        // 分库号输入重复校验
        const siteNumArr = snaps.map(v => v.siteNum!)
        const num = findFirstDuplicate(siteNumArr)
        if (num) return MessageFu.warning(`分库号${num}重复`)
      }

      const obj = {
        ...topInfo,
        goodsIds: snaps.map(v => v.id).join(','),
        siteNums: snaps.map(v => v.siteNum).join(','),
        delSnapIds: delSnapIdsRef.current.length ? delSnapIdsRef.current : '',
        snaps: snaps.map(v => ({
          goodsId: v.id,
          id: v.id2 ? v.id2 : null,
          orderId: topInfo.id,
          siteNum: v.siteNum,
          snap: JSON.stringify(v)
        }))
      }

      // console.log(123, obj.snaps)

      // if (1 + 1 === 2) return

      const res: any =
        val === '创建'
          ? await D4_APIsaveCreate(obj)
          : val === '提交'
          ? await D4_APIsaveApply(obj)
          : await D4_APIrevocation(id)

      if (res.code === 0) {
        if (sollrDom.current) sollrDom.current.scrollTop = 0
        MessageFu.success(val + '成功')
        getInfoFu()
      } else if (res.code === 3101) {
        const data = JSON.parse(res.msg || '[]')
        // setCheckArr(data)
        const siteNumArr = data.map((v: any) => v.siteNum)
        MessageFu.warning(`分库号${siteNumArr}已存在`)
      }
    },
    [getInfoFu, id, snaps, topInfo]
  )

  // 查看模式点击删除
  const delFu = useCallback(async () => {
    const res = await D4_APIdel(id)
    if (res.code === 0) {
      MessageFu.success('删除成功')
      history.push('/impStor')
    }
  }, [id])

  // 查看模式点击审批 编辑
  const lookJumpFu = useCallback(
    (val: '审批' | '编辑') => {
      history.push(`/impStor_edit/${val === '审批' ? 3 : 2}/${id}`)
      MessageFu.success(`已跳转至${val}页面`)
    },
    [id]
  )

  // 查看模式下的按钮
  const lookBtn = useMemo(() => {
    return (
      <>
        {btnFlagFu2(topInfo)['创建'] ? (
          <Button type='primary' onClick={() => lookBtnFu('创建')}>
            创建
          </Button>
        ) : null}
        {btnFlagFu2(topInfo)['提交'] ? (
          <Button type='primary' onClick={() => lookBtnFu('提交')}>
            提交
          </Button>
        ) : null}

        {btnFlagFu2(topInfo)['撤回'] ? (
          <MyPopconfirm
            txtK='撤回'
            onConfirm={() => lookBtnFu('撤回')}
            Dom={
              <Button type='primary' danger>
                撤回
              </Button>
            }
          />
        ) : null}

        {btnFlagFu2(topInfo)['审批'] ? (
          <Button type='primary' onClick={() => lookJumpFu('审批')}>
            审批
          </Button>
        ) : null}
        {btnFlagFu2(topInfo)['编辑'] ? (
          <Button type='primary' onClick={() => lookJumpFu('编辑')}>
            编辑
          </Button>
        ) : null}

        {btnFlagFu2(topInfo)['重新提交'] ? (
          <Button type='primary' onClick={() => lookBtnFu('提交')}>
            重新提交
          </Button>
        ) : null}

        {EXbtnFu({ ...topInfo, sonNum: storageIdArr.find(i => i.id === topInfo.storageId)?.num }, [
          EXPORT_WORD_ENUM.SUB_PUT_IN
        ])}

        {btnFlagFu2(topInfo)['删除'] ? (
          <MyPopconfirm
            txtK='删除'
            onConfirm={() => delFu()}
            Dom={
              <Button type='primary' danger>
                删除
              </Button>
            }
          />
        ) : null}

        <Button onClick={() => infoPageBackFu('/impStor')}>返回</Button>
      </>
    )
  }, [delFu, lookBtnFu, lookJumpFu, storageIdArr, topInfo])

  // 申请记录
  const [auditsShow, setAuditsShow] = useState(false)

  // 点击自动分配空置分库号
  const autoFu = useCallback(async () => {
    if (!topInfo.storageId) return MessageFu.warning('请先选择分库缩写')
    const res = await D4_APIgetStorageNum(snaps.length, topInfo.storageId!)
    if (res.code === 0) {
      setSnaps(
        snaps.map((v, i) => ({
          ...v,
          siteNum: res.data[i]
        }))
      )
      MessageFu.success('分配成功')
    }
  }, [snaps, topInfo.storageId])

  // 二次校验分库号
  const [checkArr, setCheckArr] = useState<D4checkArrType[]>([])

  return (
    <div className={styles.D4edit}>
      <div className='pageTitle'>藏品入库-{pageTitTxt}</div>

      <div className='D4main' ref={sollrDom}>
        {['3'].includes(key) ? (
          <X3auditInfo
            dirCode='D4impStor'
            myUrl='cms/goodsFile/upload'
            auditSta={auditSta}
            auditStaFu={val => setAuDitSta(val)}
            ref={ZAuditRef}
          />
        ) : null}

        {/* 表单字段、附件等 */}
        <div className='D4Tit'>
          申请信息
          {key === '1' ? null : (
            <Button type='dashed'>{Reflect.get(statusObj, topInfo.status)}</Button>
          )}
        </div>

        <div className='D4rowAll'>
          <div className='D4row'>
            <div className='D4rowll'>
              <span> * </span>入库日期：
            </div>
            <div className='D4rowrr'>
              <DatePicker
                disabled={['3', '4'].includes(key)}
                allowClear={false}
                value={topInfo.date ? dayjs(topInfo.date) : null}
                onChange={e => timeChange(e, 'date')}
              />
            </div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>
              <span> * </span>入库单编号：
            </div>
            <div className='D4rowrr'>
              <Input
                value={topInfo.num}
                onChange={e => setTopInfo({ ...topInfo, num: e.target.value.trim() })}
                readOnly={['3', '4'].includes(key)}
                placeholder='请输入内容'
                maxLength={30}
                showCount
              />
            </div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>
              <span> * </span>分库缩写：
            </div>
            <div className='D4rowrr'>
              <Select
                disabled={['3', '4'].includes(key)}
                placeholder='请搜索选择'
                showSearch
                filterOption={(input, option) => {
                  const txt = option!.label

                  return txt.toLowerCase().includes(input.toLowerCase())
                }}
                options={storageIdArr.map(v => ({ label: v.num + ' - ' + v.name, value: v.id }))}
                // fieldNames={{ label: 'num', value: 'num' }}
                allowClear={false}
                value={topInfo.storageId || null}
                onChange={e => {
                  setSnaps(
                    snaps.map(v => ({
                      ...v,
                      siteNum: null
                    }))
                  )
                  setTopInfo({ ...topInfo, storageId: e ? e : null })
                }}
              />
            </div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>发掘报告编号：</div>
            <div className='D4rowrr'>
              <Input
                value={topInfo.sonNum2}
                onChange={e => setTopInfo({ ...topInfo, sonNum2: e.target.value.trim() })}
                readOnly={['3', '4'].includes(key)}
                placeholder={['3', '4'].includes(key) ? '（空）' : '请输入内容'}
                maxLength={30}
                showCount
              />
            </div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>入馆凭证号：</div>
            <div className='D4rowrr'>
              <Select
                disabled={['3', '4'].includes(key)}
                placeholder={['3', '4'].includes(key) ? '（空）' : '请搜索选择'}
                showSearch
                filterOption={(input, option) => {
                  const txt = option!.label

                  return txt.toLowerCase().includes(input.toLowerCase())
                }}
                options={relatedOrderNumArr
                  .filter(c => c.status === 4)
                  .map(v => ({ label: v.num, value: v.num }))}
                // fieldNames={{ label: 'num', value: 'num' }}
                allowClear={true}
                value={topInfo.relatedOrderNum || null}
                onChange={e => setTopInfo({ ...topInfo, relatedOrderNum: e ? e : '' })}
              />
            </div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>来源：</div>
            <div className='D4rowrr'>
              <Cascader
                value={topInfo.sonSource ? topInfo.sonSource.split(',') : []}
                onChange={e => setTopInfo({ ...topInfo, sonSource: e ? e.join(',') : '' })}
                disabled={['3', '4'].includes(key)}
                options={cascaderObjFu()['藏品入库']}
                changeOnSelect
                placeholder={['3', '4'].includes(key) ? '（空）' : '请选择'}
                fieldNames={{ label: 'name', value: 'id', children: 'children' }}
                allowClear={true}
              />
            </div>
          </div>
        </div>

        {/* 藏品清单 */}
        <div className='D4googsBox'>
          <div className='D4Tit2'>
            <div className='D4Tit2ll'>藏品清单</div>
            <div className='D4Tit2rr'>
              {['3', '4'].includes(key) ? null : (
                <>
                  <Button type='primary' onClick={autoFu} disabled={snaps.length === 0}>
                    自动分配空置分库号
                  </Button>
                  &emsp;
                  <Button
                    type='primary'
                    onClick={() => {
                      // if (!topInfo.storageId) return MessageFu.warning('请先选择分库缩写')
                      setNowSta({
                        key: '藏品入库',
                        id: 'cms/orderIn/goods/getList'
                      })
                    }}
                  >
                    新增
                  </Button>
                </>
              )}
            </div>
          </div>

          {/* 表格 */}
          <MyTable
            list={snaps}
            columnsTemp={D4tableCgoods}
            startBtn={startBtn}
            lastBtn={tableLastBtn}
            pagingInfo={false}
          />
        </div>

        {/* 申请流程 */}
        {auditsShow ? (
          <ZflowTable tableArr={topInfo.audits || []} closeFu={() => setAuditsShow(false)} />
        ) : null}

        {/* 底部按钮 */}
        <div className='D4btn'>
          {['3', '4'].includes(key) &&
          topInfo.audits &&
          topInfo.audits.length &&
          [2, 3, 4].includes(topInfo.status) ? (
            <Button type='primary' onClick={() => setAuditsShow(true)}>
              申请记录
            </Button>
          ) : null}

          {key === '4' ? (
            lookBtn
          ) : (
            <>
              {key === '3' ? (
                <Button type='primary' onClick={() => btnClickFu('审批')}>
                  审批
                </Button>
              ) : (
                <Button type='primary' onClick={() => btnClickFu(key === '1' ? '创建' : '保存')}>
                  {key === '1' ? '创建' : '保存'}
                </Button>
              )}

              {key === '1' ? (
                <Button type='primary' onClick={() => btnClickFu('草稿')}>
                  存草稿
                </Button>
              ) : null}

              <MyPopconfirm txtK='取消' onConfirm={() => history.push('/impStor')} />
            </>
          )}
        </div>

        {/* 附件归档 */}
        {topInfo.status === 4 ? (
          <ZupFileTable
            listTemp={topInfo.filing || []}
            dirCode='D4impStor'
            myUrl='cms/orderIn/upload'
            fromData={{ moduleId: topInfo.id }}
          />
        ) : null}
      </div>

      {/* 打开侧边栏 */}
      <Y1cathet sId={cathet} closeFu={() => setCathet(0)} />

      {nowSta.id ? (
        <ZGaddNow
          menuId={7}
          orderId={topInfo.id}
          nowSta={nowSta}
          checkboxProps={item => ({
            disabled: ![0, 4].includes(item.statusStorage)
          })}
          closeFu={() => setNowSta({ key: '', id: '' })}
          dataResFu={data => {
            const dataTemp = [...data]
            dataTemp.forEach(v => {
              // id2表示的是自己这条数据的id id才是goodsId
              const obj = snapsID2ref.current.find(c => c.goodsId === v.id)

              if (obj) v.id2 = obj.id
            })
            setSnaps(dataTemp)
          }}
          oldCheckArr={snaps}
        />
      ) : null}

      {/* 二次校验分库号 */}
      {checkArr.length ? (
        <D4check
          storageId={Number(topInfo.storageId)}
          closeFu={() => setCheckArr([])}
          listTemp={checkArr}
          waiSiteNumArr={snaps.map(v => v.siteNum!)}
          type='入库'
        />
      ) : null}
    </div>
  )
}

const MemoD4edit = React.memo(D4edit)

export default MemoD4edit
